#ifndef CATEGORY_H
#define CATEGORY_H
#include "data.h"

class Category :public Data
{
public:
    Category(QString name = QString(""),
             QVector<int> kihonCapability = QVector<int>(5,0),
             QVector<int> sentouCapability = QVector<int>(5,0),
             QTableWidget *tokugiTableWidget = new QTableWidget(0),
             QList<Data*> autoGetTokugiList = QList<Data*>());
    virtual ~Category();
    virtual bool Add(Data *data);
    virtual bool Remove(Data *data);
    virtual Category* GetCategory();
    virtual Data* findCategory(QString name);
    virtual QVector<int> GetKihonCapability();
    virtual int GetKihonCapability(int);
    virtual bool SetKihonCapability(QVector<int>);
    virtual QVector<int> GetSentouCapability();
    virtual int GetSentouCapability(int);
    virtual bool SetSentouCapability(QVector<int>);
    virtual QList<Data*> getAutoGetTokugiList();
    virtual bool addAutGetTokugiList(Data *tokugi);
    virtual QTableWidget* getTokugiTableWidget();
    virtual bool setTokugiTableWidget(QTableWidget *qw);

protected:
    QVector<int> _kihonCapability;
    QVector<int> _sentouCapability;
    QTableWidget *_tokugiTableWidget;
    QList<Data*> _autoGetTokugiList;
};

#endif // CATEGORY_H
