#ifndef CATEGORYWINDOW_H
#define CATEGORYWINDOW_H

#include <QWidget>
#include <QTableWidget>
#include <QTableWidgetItem>
#include "data.h"
#include "tokugi.h"

class CategoryWindow : public QWidget
{
public:
    explicit CategoryWindow(QWidget *parent =0);
    virtual ~CategoryWindow();

    virtual bool setGeneral(Data*);
    template<class T> bool addCategory(QTableWidget* qtw, Data* parent, QList<Data*>& childList, T*);
    virtual QHash<int, Data*> ShowTokugi(QTableWidget* categoryTableWidget, QTableWidget* tokugiTableWidget, QList<Data*> categoryList);
    virtual Data* getTokugi(QTableWidget* category, QTableWidget* tokugi, QList<Data*>);
    virtual bool setSelectedCategory(Data *data);
    virtual Data* getSelectedCategory();

    virtual QTableWidget* showTokugiTableWidget(Data *data);

protected:
    Data* _general;
    Data *_selectedCategory;
};

#endif // CATEGORYWINDOW_H
